/*
 * OSM NB API featuring ETSI NFV SOL005
 * This is Open Source MANO Northbound API featuring ETSI NFV SOL005. For more information on OSM, you can visit [http://osm.etsi.org](http://osm.etsi.org). You can send us your comments and questions to OSM_TECH@list.etsi.org or join the [OpenSourceMANO Slack Workplace](https://join.slack.com/t/opensourcemano/shared_invite/enQtMzQ3MzYzNTQ0NDIyLWVkNTE4ZjZjNWI0ZTQyN2VhOTI1MjViMzU1NWYwMWM3ODI4NTQyY2VlODA2ZjczMWIyYTFkZWNiZmFkM2M2ZDk) 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: OSM_TECH@list.etsi.org
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.lcm.nfvo.osm.rest.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.Objects;

/**
 * NSinstanceActionRequest
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-03-04T13:48:18.253Z[GMT]")
public class NSinstanceActionRequest {
  @SerializedName("primitive")
  private String primitive = null;

  @SerializedName("primitive_params")
  private KeyValuePairs primitiveParams = null;

  @SerializedName("member_vnf_index")
  private String memberVnfIndex = null;

  @SerializedName("vdu_id")
  private String vduId = null;

  @SerializedName("kdu_name")
  private String kduName = null;

  @SerializedName("vdu_count_index")
  private Integer vduCountIndex = null;

  @SerializedName("timeout_ns_action")
  private Integer timeoutNsAction = null;

  public NSinstanceActionRequest primitive(String primitive) {
    this.primitive = primitive;
    return this;
  }

   /**
   * name of the primitive in the &#x27;config-descriptor&#x27;. If the target is a kdu it can be also &#x27;status&#x27;, &#x27;rollback&#x27; or &#x27;upgrade&#x27; 
   * @return primitive
  **/
  @Schema(required = true, description = "name of the primitive in the 'config-descriptor'. If the target is a kdu it can be also 'status', 'rollback' or 'upgrade' ")
  public String getPrimitive() {
    return primitive;
  }

  public void setPrimitive(String primitive) {
    this.primitive = primitive;
  }

  public NSinstanceActionRequest primitiveParams(KeyValuePairs primitiveParams) {
    this.primitiveParams = primitiveParams;
    return this;
  }

   /**
   * Get primitiveParams
   * @return primitiveParams
  **/
  @Schema(required = true, description = "")
  public KeyValuePairs getPrimitiveParams() {
    return primitiveParams;
  }

  public void setPrimitiveParams(KeyValuePairs primitiveParams) {
    this.primitiveParams = primitiveParams;
  }

  public NSinstanceActionRequest memberVnfIndex(String memberVnfIndex) {
    this.memberVnfIndex = memberVnfIndex;
    return this;
  }

   /**
   * provide if the target action is for a vnf, vdu or kdu
   * @return memberVnfIndex
  **/
  @Schema(description = "provide if the target action is for a vnf, vdu or kdu")
  public String getMemberVnfIndex() {
    return memberVnfIndex;
  }

  public void setMemberVnfIndex(String memberVnfIndex) {
    this.memberVnfIndex = memberVnfIndex;
  }

  public NSinstanceActionRequest vduId(String vduId) {
    this.vduId = vduId;
    return this;
  }

   /**
   * provide if the target action is for a vdu
   * @return vduId
  **/
  @Schema(description = "provide if the target action is for a vdu")
  public String getVduId() {
    return vduId;
  }

  public void setVduId(String vduId) {
    this.vduId = vduId;
  }

  public NSinstanceActionRequest kduName(String kduName) {
    this.kduName = kduName;
    return this;
  }

   /**
   * provide if the target action is for a kdu
   * @return kduName
  **/
  @Schema(description = "provide if the target action is for a kdu")
  public String getKduName() {
    return kduName;
  }

  public void setKduName(String kduName) {
    this.kduName = kduName;
  }

  public NSinstanceActionRequest vduCountIndex(Integer vduCountIndex) {
    this.vduCountIndex = vduCountIndex;
    return this;
  }

   /**
   * Get vduCountIndex
   * @return vduCountIndex
  **/
  @Schema(description = "")
  public Integer getVduCountIndex() {
    return vduCountIndex;
  }

  public void setVduCountIndex(Integer vduCountIndex) {
    this.vduCountIndex = vduCountIndex;
  }

  public NSinstanceActionRequest timeoutNsAction(Integer timeoutNsAction) {
    this.timeoutNsAction = timeoutNsAction;
    return this;
  }

   /**
   * timeout for the day 1/2 operation
   * @return timeoutNsAction
  **/
  @Schema(description = "timeout for the day 1/2 operation")
  public Integer getTimeoutNsAction() {
    return timeoutNsAction;
  }

  public void setTimeoutNsAction(Integer timeoutNsAction) {
    this.timeoutNsAction = timeoutNsAction;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NSinstanceActionRequest nsinstanceActionRequest = (NSinstanceActionRequest) o;
    return Objects.equals(this.primitive, nsinstanceActionRequest.primitive) &&
        Objects.equals(this.primitiveParams, nsinstanceActionRequest.primitiveParams) &&
        Objects.equals(this.memberVnfIndex, nsinstanceActionRequest.memberVnfIndex) &&
        Objects.equals(this.vduId, nsinstanceActionRequest.vduId) &&
        Objects.equals(this.kduName, nsinstanceActionRequest.kduName) &&
        Objects.equals(this.vduCountIndex, nsinstanceActionRequest.vduCountIndex) &&
        Objects.equals(this.timeoutNsAction, nsinstanceActionRequest.timeoutNsAction);
  }

  @Override
  public int hashCode() {
    return Objects.hash(primitive, primitiveParams, memberVnfIndex, vduId, kduName, vduCountIndex, timeoutNsAction);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NSinstanceActionRequest {\n");
    
    sb.append("    primitive: ").append(toIndentedString(primitive)).append("\n");
    sb.append("    primitiveParams: ").append(toIndentedString(primitiveParams)).append("\n");
    sb.append("    memberVnfIndex: ").append(toIndentedString(memberVnfIndex)).append("\n");
    sb.append("    vduId: ").append(toIndentedString(vduId)).append("\n");
    sb.append("    kduName: ").append(toIndentedString(kduName)).append("\n");
    sb.append("    vduCountIndex: ").append(toIndentedString(vduCountIndex)).append("\n");
    sb.append("    timeoutNsAction: ").append(toIndentedString(timeoutNsAction)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
